
.386
.model flat, stdcall
option casemap :none

include windows.inc
include user32.inc
include kernel32.inc

includelib user32.lib
includelib kernel32.lib

__EVENT UNION
  KeyEvent              KEY_EVENT_RECORD          <>
  MouseEvent            MOUSE_EVENT_RECORD        <>
  WindowBufferSizeEvent WINDOW_BUFFER_SIZE_RECORD <>
  MenuEvent             MENU_EVENT_RECORD         <>
  FocusEvent            FOCUS_EVENT_RECORD        <>
__EVENT ENDS

INPUT_RECORD STRUC
  EventType WORD    ?
            WORD    ? ; __alignmentDummy
  Event     __EVENT <>
INPUT_RECORD ENDS

.const
  szFmtFailedCode                 db '%s failed, error code %d',13,10,0
  szGetStdHandle                  db 'GetStdHandle',0
  szWaitForSingleObject           db 'WaitForSingleObject',0
  szGetNumberOfConsoleInputEvents db 'GetNumberOfConsoleInputEvents',0
  szReadConsoleInput              db 'ReadConsoleInput',0
  szFmtChoice                     db 'You have pressed ',27h,'%d',27h,13,10,0
  szPrompt                        db 'Press the key of your choice',13,10
                                  db '1) Option A',13,10
                                  db '2) Option B',13,10
                                  db '3) Exit',13,10,0

.code

;-------------------------------------------------------------------;
  even
  SimplePrintf proc C, pszFormat, param:VARARG
    local buffer[2048]:byte
    local hOutPut:dword
    local bWritten:dword

    invoke wvsprintf, addr buffer, pszFormat, addr param
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hOutPut,eax
    invoke lstrlen,addr buffer
    mov ecx,eax
    invoke WriteFile, hOutPut, addr buffer, ecx, addr bWritten, NULL
    mov eax, bWritten
    ret
  SimplePrintf endp

;-------------------------------------------------------------------;
  even
  main proc uses ebx esi
    local ir              : INPUT_RECORD
    local NumOfEvents     : dword
    local NumOfEventsRead : dword

    invoke GetStdHandle, STD_INPUT_HANDLE
    .if eax == INVALID_HANDLE_VALUE
      invoke GetLastError
      invoke SimplePrintf, offset szFmtFailedCode,\
                           offset szGetStdHandle, eax
      jmp @@exit
    .endif
    mov esi,eax

    invoke SimplePrintf, offset szPrompt

    .while 1

      invoke WaitForSingleObject, esi, INFINITE
      .if eax ==  WAIT_FAILED
        invoke GetLastError
        invoke SimplePrintf, offset szFmtFailedCode,\
                             offset szWaitForSingleObject, eax
        jmp @@exit
      .endif
      
      invoke GetNumberOfConsoleInputEvents, esi, addr NumOfEvents
      .if eax == FALSE
        invoke GetLastError
        invoke SimplePrintf, offset szFmtFailedCode,\
                             offset szGetNumberOfConsoleInputEvents, eax
        jmp @@exit
      .endif

      xor ebx,ebx
      .while ebx < NumOfEvents
        invoke ReadConsoleInput, esi, addr ir, 1, addr NumOfEventsRead
        .if eax == FALSE
          invoke GetLastError
          invoke SimplePrintf, offset szFmtFailedCode,\
                               offset szReadConsoleInput, eax
          jmp @@exit
        .endif
        .if NumOfEventsRead == 1
          .if (ir.EventType               == KEY_EVENT) && \
              (ir.Event.KeyEvent.bKeyDown == TRUE)
            mov al,ir.Event.KeyEvent.uChar.AsciiChar
            .if al == '1' || al == '2' || al == '3'
              sub al,'1'-1
              and eax,3
              invoke SimplePrintf, offset szFmtChoice, eax
              jmp @@exit
            .endif
          .endif
        .endif
        inc ebx
      .endw

    .endw
  @@exit:
    ret
  main endp

;-------------------------------------------------------------------;
  even
  start:
    invoke main
    invoke ExitProcess, 0

end start
